unit uart8051;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    LabelQuartz: TLabel;
    EditQuartz: TEdit;
    LabelMHz: TLabel;
    TabSheet2: TTabSheet;
    LabelCommon: TLabel;
    ComboCommon: TComboBox;
    LabelDesiredBaud: TLabel;
    EditDesiredBaud: TEdit;
    GroupBoxParamMode0: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EditParmMode0ReachedBaud: TEdit;
    EditParmMode0Deviation: TEdit;
    GroupBoxParamMode1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    EditParmMode1TLTH: TEdit;
    EditParmMode1ReachedBaud: TEdit;
    EditParmMode1Deviation: TEdit;
    CheckBoxParmMode1SMOD: TCheckBox;
    GroupBoxParamMode2: TGroupBox;
    CheckBoxParmMode2SMOD: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    EditParmMode2ReachedBaud: TEdit;
    EditParmMode2Deviation: TEdit;
    GroupBox1: TGroupBox;
    RadioButtonBaudMode0: TRadioButton;
    RadioButtonBaudMode1: TRadioButton;
    RadioButtonBaudMode2: TRadioButton;
    GroupBox2: TGroupBox;
    LabelBaudTLTH: TLabel;
    CheckBoxBaudSMOD: TCheckBox;
    EditBaudTLTH: TEdit;
    GroupBox3: TGroupBox;
    EditBaudBaudrate: TEdit;
    TabSheetCalcQuartz: TTabSheet;
    Label8: TLabel;
    EditQuartzDesiredBaud: TEdit;
    GroupBoxQuartzMode0: TGroupBox;
    Label9: TLabel;
    EditQuartzMode0Freq: TEdit;
    Label10: TLabel;
    GroupBoxQuartzMode2: TGroupBox;
    Label11: TLabel;
    LabelSMOD1: TLabel;
    LabelSMOD0: TLabel;
    EditQuartzMode2SMOD0: TEdit;
    EditQuartzMode2SMOD1: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    GroupBoxQuartzMode1: TGroupBox;
    StringGridQuartzMode1: TStringGrid;
    procedure ComboCommonChange(Sender: TObject);
    procedure EditQuartzChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxParmMode1SMODClick(Sender: TObject);
    procedure CheckBoxParmMode2SMODClick(Sender: TObject);
    procedure EditDesiredBaudChange(Sender: TObject);
    procedure RadioButtonBaudMode1Click(Sender: TObject);
    procedure RadioButtonBaudMode0Click(Sender: TObject);
    procedure RadioButtonBaudMode2Click(Sender: TObject);
    procedure CheckBoxBaudSMODClick(Sender: TObject);
    procedure EditBaudTLTHChange(Sender: TObject);
    procedure TabSheetCalcQuartzShow(Sender: TObject);
    procedure TabSheetCalcQuartzHide(Sender: TObject);
    procedure EditQuartzDesiredBaudChange(Sender: TObject);
    procedure StringGridQuartzMode1SelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure CalculateParms;
    procedure CalculateBaud;
    procedure CalculateQuartz;
    procedure SMODstate(state : boolean);
  end;

var
  Form1: TForm1;

const
  OSC_FREQ_MHZ_MAX = 100;

implementation

{$R *.DFM}

procedure TForm1.CalculateParms();
var
  OscFreq : Real;
  DesiredBaud : Integer;
  dummy   : integer;
  SMOD : Byte;
  TH1 : integer;
  ReachedBaud : Real;
  Deviation : Real;
begin
  val(EditQuartz.Text, OscFreq, dummy);
  OscFreq := OscFreq * 1000000;
  val(EditDesiredBaud.Text, DesiredBaud, dummy);

  if ((DesiredBaud = 0) or (OscFreq = 0)) then begin
    EditParmMode0ReachedBaud.Text := '';
    EditParmMode0Deviation.Text := '';
    EditParmMode1TLTH.Text := '';
    EditParmMode1ReachedBaud.Text := '';
    EditParmMode1Deviation.Text := '';
    EditParmMode2ReachedBaud.Text := '';
    EditParmMode2Deviation.Text := '';
    exit;
  end;

  // mode 0:
  ReachedBaud := OscFreq / 12;
  Deviation := abs(ReachedBaud-DesiredBaud) / DesiredBaud * 100;
  EditParmMode0ReachedBaud.Text := FormatFloat('#,###,##0', ReachedBaud);
  EditParmMode0Deviation.Text := FormatFloat('###0.00', Deviation)+'%';
  // modes 1 & 3:
  if (CheckBoxParmMode1SMOD.Checked) then SMOD := 1 else SMOD := 0;
  TH1 := Round( 256 - ((SMOD+1)*OscFreq) / (384*DesiredBaud) );
  if (TH1 > 255) then TH1 := 255;
  if (TH1 < 0) then TH1 := 0;
  ReachedBaud := ((SMOD+1)*OscFreq) / (32*12*(256-TH1));
  Deviation := abs(ReachedBaud-DesiredBaud) / DesiredBaud * 100;
  EditParmMode1TLTH.Text := IntToStr(TH1);
  EditParmMode1ReachedBaud.Text := FormatFloat('###,##0', ReachedBaud);
  EditParmMode1Deviation.Text := FormatFloat('###0.00', Deviation)+'%';
  // mode 2:
  if (CheckBoxParmMode2SMOD.Checked) then SMOD := 1 else SMOD := 0;
  ReachedBaud := OscFreq / (32*(2-SMOD));
  Deviation := abs(ReachedBaud-DesiredBaud) / DesiredBaud * 100;
  EditParmMode2ReachedBaud.Text := FormatFloat('#,###,##0', ReachedBaud);
  EditParmMode2Deviation.Text := FormatFloat('###0.00', Deviation)+'%';
end;

procedure TForm1.CalculateBaud();
var
  OscFreq : Real;
  dummy   : integer;
  SMOD : Byte;
  TH1 : integer;
  ReachedBaud : Real;
begin
  val(EditQuartz.Text, OscFreq, dummy);
  OscFreq := OscFreq * 1000000;
  val(EditBaudTLTH.Text, TH1, dummy);
  if (CheckBoxBaudSMOD.Checked = true) then SMOD := 1 else SMOD := 0;
  if (TH1 > 255) then TH1 := 255;
  if (TH1 < 0) then TH1 := 0;
  EditBaudTLTH.Text := IntToStr(TH1);

  if (OscFreq = 0) then begin
    EditBaudBaudrate.Text := '';
    exit;
  end;

  if (RadioButtonBaudMode0.Checked = true) then begin
    // mode 0
    ReachedBaud := OscFreq / 12;
    EditBaudBaudrate.Text := FormatFloat('#,###,##0', ReachedBaud);
  end else if (RadioButtonBaudMode1.Checked = true) then begin
    // modes 1 & 3
    ReachedBaud := ((SMOD+1)*OscFreq) / (32*12*(256-TH1));
    EditBaudBaudrate.Text := FormatFloat('###,##0', ReachedBaud);
  end else if (RadioButtonBaudMode2.Checked = true) then begin
    ReachedBaud := OscFreq / (32*(2-SMOD));
    EditBaudBaudrate.Text := FormatFloat('#,###,##0', ReachedBaud);
  end;
end;

procedure TForm1.CalculateQuartz();
var
  DesiredBaud : integer;
  OscFreqMHz : Extended;
  dummy   : integer;
  TH1 : byte;
  line : word;
begin
  val(EditQuartzDesiredBaud.Text, DesiredBaud, dummy);

  if (DesiredBaud = 0) then begin
    EditQuartzMode0Freq.Text := '';
    EditQuartzMode2SMOD0.Text := '';
    EditQuartzMode2SMOD1.Text := '';
    StringGridQuartzMode1.RowCount := 2;
    StringGridQuartzMode1.Rows[0].CommaText := 'TH1/TL1,SMOD,"Quartz frequency"';
    StringGridQuartzMode1.Rows[1].Text := '';
    exit;
  end;

  // mode 0:
  OscFreqMHz := 12 / 1000000 * DesiredBaud;
  EditQuartzMode0Freq.Text := FormatFloat('##0.#####', OscFreqMHz);
  // modes 1 & 3:
   // TODO: sort items by quartz frequency
  StringGridQuartzMode1.Rows[0].CommaText := 'TH1/TL1,SMOD,"Quartz frequency"';
  line := 1;
  for TH1 := 255 downto 0 do begin
     // BaudRate := ((SMOD+1)*OscFreq) / (32*12*(256-TH1))
     // OscFreqMHz := DesiredBaud / 1000000 / 2 * (32*12*(256-TH1));
     OscFreqMHz := DesiredBaud / 15625 * 3 * (256-TH1);
     if ((OscFreqMHz <= OSC_FREQ_MHZ_MAX) and (OscFreqMHz > 0)) then begin
       StringGridQuartzMode1.Rows[line].CommaText := IntToStr(TH1)+',1,"'
                          + FormatFloat('##0.#####" MHz"',OscFreqMHz)+'"';
       inc(line);
     end;
     // OscFreqMHz := DesiredBaud / 1000000 * (32*12*(256-TH1));
     OscFreqMHz := DesiredBaud / 15625 * 6 * (256-TH1);
     if ((OscFreqMHz <= OSC_FREQ_MHZ_MAX) and (OscFreqMHz > 0)) then begin
       StringGridQuartzMode1.Rows[line].CommaText := IntToStr(TH1)+',0,"'
                          + FormatFloat('##0.#####" MHz"',OscFreqMHz)+'"';
       inc(line);
     end;
  end;
  if (line = 1) then begin
    inc(line);
    StringGridQuartzMode1.Rows[1].Text := '';
  end;
  StringGridQuartzMode1.RowCount := line;
  // mode 2:
  OscFreqMHz := 64 / 1000000 * DesiredBaud;
  EditQuartzMode2SMOD0.Text := FormatFloat('##0.#####', OscFreqMHz);
  OscFreqMHz := 32 / 1000000 * DesiredBaud;
  EditQuartzMode2SMOD1.Text := FormatFloat('##0.#####', OscFreqMHz);
end;

procedure TForm1.SMODstate(state : boolean);
begin
//  CheckBoxBaudSMOD.Checked := state;
  CheckBoxParmMode1SMOD.Checked := state;
  CheckBoxParmMode2SMOD.Checked := state;
end;

procedure TForm1.ComboCommonChange(Sender: TObject);
var
  real_var : real;
  dummy : integer;
begin
  val(ComboCommon.Text, real_var, dummy);
  if (real_var = 0) then exit;
  EditQuartz.Text := ComboCommon.Text;
end;

procedure TForm1.EditQuartzChange(Sender: TObject);
begin
  CalculateParms;
  CalculateBaud;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CalculateParms;
  CalculateBaud;
end;

procedure TForm1.CheckBoxParmMode2SMODClick(Sender: TObject);
begin
  SMODstate(CheckBoxParmMode2SMOD.Checked);
  CalculateParms;
end;

procedure TForm1.CheckBoxParmMode1SMODClick(Sender: TObject);
begin
  SMODstate(CheckBoxParmMode1SMOD.Checked);
  CalculateParms;
end;

procedure TForm1.EditDesiredBaudChange(Sender: TObject);
begin
  CalculateParms;
end;

procedure TForm1.RadioButtonBaudMode1Click(Sender: TObject);
begin
  EditBaudTLTH.Enabled := true;
  LabelBaudTLTH.Enabled := true;
  CheckBoxBaudSMOD.Enabled := true;
  CalculateBaud;
end;

procedure TForm1.RadioButtonBaudMode0Click(Sender: TObject);
begin
  EditBaudTLTH.Enabled := false;
  LabelBaudTLTH.Enabled := false;
  CheckBoxBaudSMOD.Enabled := false;
  CalculateBaud;
end;

procedure TForm1.RadioButtonBaudMode2Click(Sender: TObject);
begin
  EditBaudTLTH.Enabled := false;
  LabelBaudTLTH.Enabled := false;
  CheckBoxBaudSMOD.Enabled := true;
  CalculateBaud;
end;

procedure TForm1.CheckBoxBaudSMODClick(Sender: TObject);
begin
//  SMODstate(CheckBoxBaudSMOD.Checked);
  CalculateBaud;
end;

procedure TForm1.EditBaudTLTHChange(Sender: TObject);
begin
  CalculateBaud;
end;

procedure TForm1.TabSheetCalcQuartzShow(Sender: TObject);
begin
  LabelQuartz.Enabled := false;
  EditQuartz.Enabled := false;
  LabelMHz.Enabled := false;
  LabelCommon.Enabled := false;
  ComboCommon.Enabled := false;
  CalculateQuartz;
end;

procedure TForm1.TabSheetCalcQuartzHide(Sender: TObject);
begin
  LabelQuartz.Enabled := true;
  EditQuartz.Enabled := true;
  LabelMHz.Enabled := true;
  LabelCommon.Enabled := true;
  ComboCommon.Enabled := true;
end;

procedure TForm1.EditQuartzDesiredBaudChange(Sender: TObject);
begin
  CalculateQuartz;
end;

procedure TForm1.StringGridQuartzMode1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var
  OscFreqMHz : Extended;
  SMOD : Byte;
  TH1 : Byte;
  dummy : integer;
  DesiredBaud : extended;
begin
  if ((ACol = 2) and (StringGridQuartzMode1.Rows[1].Text <> #13#10#13#10#13#10)) then begin
     val(EditQuartzDesiredBaud.Text, DesiredBaud, dummy);
     if (DesiredBaud = 0) then exit;
     val(StringGridQuartzMode1.Cells[0, ARow], TH1, dummy);
     val(StringGridQuartzMode1.Cells[1, ARow], SMOD, dummy);
     OscFreqMHz := DesiredBaud / 15625 * 3 * (2-SMOD) * (256-TH1);
     EditQuartz.Text := FormatFloat('##0.#####', OscFreqMHz);
  end else CanSelect := false;
end;

begin
  DecimalSeparator := '.'; // val() needs this
  ThousandSeparator := ',';
end.
